"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime-corejs3/helpers/interopRequireWildcard");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var path = _interopRequireWildcard(require("path"));

var _mp = require("@mpjs/mp");

var _plugins = require("@mpjs/mp/plugins");

var _mpPluginWebpack = _interopRequireDefault(require("@mpjs/mp-plugin-webpack"));

var _prefix = _interopRequireDefault(require("./prefix"));

const isDev = process.env.NODE_ENV === "development";

class VuePlugin extends _mp.Plugin {
  constructor({
    onlyConfig = false
  } = {}) {
    super(`${_prefix.default}/index`);
    this.onlyConfig = onlyConfig;
  }
  /* eslint-disable class-methods-use-this */


  getDependencies() {
    return [new _mpPluginWebpack.default({
      onlyConfig: this.onlyConfig
    }), new _plugins.AutoAssignConfig(path.resolve(__dirname, "./config"))];
  }
  /* eslint-enable class-methods-use-this */


  apply(hooks) {
    hooks.config.tapPromise(this.pluginKey, async ({
      onItemDone
    }) => {
      let enableHot = false;
      onItemDone("webpack-server", ({
        hot
      }) => {
        enableHot = isDev && hot;
      });
      onItemDone("webpack", config => {
        config.module.rules.push({
          test: /\.vue$/,
          loader: "vue-loader",
          options: {
            hotReload: enableHot
          }
        });
      });
    });
  }

}

var _default = VuePlugin;
exports.default = _default;